.macro	xpc
	ldx	process_count
.endmacro

.macro	ypc
	ldy	process_count
.endmacro

.macro	set	variable,value
	lda	value
	sta	variable
.endmacro

.macro	rangeset	variable,range,value
.ifblank	value
	lda	#0
.else
	lda	value
.endif
;.if range < $81
;	ldx	range
;:	sta	variable,x
;	dex
;	bpl	:-
;.else
	ldx	range
	inx
:	sta	variable-1,x
	dex
	bne	:-
;.endif
.endmacro
 
.macro	sprset	slot,tile,Yc,Xc,attr
	lda	tile
	sta	$201+(slot*4)
	lda	attr
	sta	$202+(slot*4)
	lda	Yc-1
	sta	$200+(slot*4)
	lda	Xc
	sta	$203+(slot*4)
.endmacro

.macro	sprremove	slot
	lda	#$F8
	sta	$200+(slot*4)
.endmacro

.macro	waitcl	memory
	lda	memory
	beq	:+
	rts
:
.endmacro

.macro	stadium_init	stadiumID
	lda	stadiumID
	sta	stadium
	inc	stadium_initrig
.endmacro

.macro	clFC loadx
.ifnblank loadx
	xpc
.endif
	lda	#0
	sta	process_FC,x
.endmacro

.macro	waitFC	framesval, loadx
.ifnblank loadx
	xpc
.endif
	lda	process_FC,x
	cmp	framesval
	bcs	:+
	rts
:
	lda	#0
	sta	process_FC,x
.endmacro

.macro	delayframe loadx
.ifnblank loadx
	xpc
.endif
	lda	process_FC,x
	bne	:+
	rts
:	lda	#0
	sta	process_FC,x
.endmacro

.macro	getR0	loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R0,x
.endmacro
.macro	getR1	loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R1,x
.endmacro
.macro	getR2	loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R2,x
.endmacro
.macro	getR3	loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R3,x
.endmacro
.macro	getR4	loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R4,x
.endmacro
.macro	getR5	loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R5,x
.endmacro
.macro	getR6	loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R6,x
.endmacro
.macro	getR7	loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R7,x
.endmacro

.macro	setR0	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	value
	sta	process_R0,x
.endmacro
.macro	setR1	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	value
	sta	process_R1,x
.endmacro
.macro	setR2	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	value
	sta	process_R2,x
.endmacro
.macro	setR3	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	value
	sta	process_R3,x
.endmacro
.macro	setR4	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	value
	sta	process_R4,x
.endmacro
.macro	setR5	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	value
	sta	process_R5,x
.endmacro
.macro	setR6	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	value
	sta	process_R6,x
.endmacro
.macro	setR7	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	value
	sta	process_R7,x
.endmacro

.macro	cmpR0	loadx
.ifnblank	loadx
	xpc
.endif
	cmp	process_R0,x
.endmacro
.macro	cmpR1	loadx
.ifnblank	loadx
	xpc
.endif
	cmp	process_R1,x
.endmacro
.macro	cmpR2	loadx
.ifnblank	loadx
	xpc
.endif
	cmp	process_R2,x
.endmacro
.macro	cmpR3	loadx
.ifnblank	loadx
	xpc
.endif
	cmp	process_R3,x
.endmacro
.macro	cmpR4	loadx
.ifnblank	loadx
	xpc
.endif
	cmp	process_R4,x
.endmacro
.macro	cmpR5	loadx
.ifnblank	loadx
	xpc
.endif
	cmp	process_R5,x
.endmacro
.macro	cmpR6	loadx
.ifnblank	loadx
	xpc
.endif
	cmp	process_R6,x
.endmacro
.macro	cmpR7	loadx
.ifnblank	loadx
	xpc
.endif
	cmp	process_R7,x
.endmacro

.macro	incR0	loadx
.ifnblank	loadx
	xpc
.endif
	inc	process_R0,x
.endmacro
.macro	incR1	loadx
.ifnblank	loadx
	xpc
.endif
	inc	process_R1,x
.endmacro
.macro	incR2	loadx
.ifnblank	loadx
	xpc
.endif
	inc	process_R2,x
.endmacro
.macro	incR3	loadx
.ifnblank	loadx
	xpc
.endif
	inc	process_R3,x
.endmacro
.macro	incR4	loadx
.ifnblank	loadx
	xpc
.endif
	inc	process_R4,x
.endmacro
.macro	incR5	loadx
.ifnblank	loadx
	xpc
.endif
	inc	process_R5,x
.endmacro
.macro	incR6	loadx
.ifnblank	loadx
	xpc
.endif
	inc	process_R6,x
.endmacro
.macro	incR7	loadx
.ifnblank	loadx
	xpc
.endif
	inc	process_R7,x
.endmacro

.macro	decR0	loadx
.ifnblank	loadx
	xpc
.endif
	dec	process_R0,x
.endmacro
.macro	decR1	loadx
.ifnblank	loadx
	xpc
.endif
	dec	process_R1,x
.endmacro
.macro	decR2	loadx
.ifnblank	loadx
	xpc
.endif
	dec	process_R2,x
.endmacro
.macro	decR3	loadx
.ifnblank	loadx
	xpc
.endif
	dec	process_R3,x
.endmacro
.macro	decR4	loadx
.ifnblank	loadx
	xpc
.endif
	dec	process_R4,x
.endmacro
.macro	decR5	loadx
.ifnblank	loadx
	xpc
.endif
	dec	process_R5,x
.endmacro
.macro	decR6	loadx
.ifnblank	loadx
	xpc
.endif
	dec	process_R6,x
.endmacro
.macro	decR7	loadx
.ifnblank	loadx
	xpc
.endif
	dec	process_R7,x
.endmacro

.macro	addR0	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R0,x
	clc
	adc	value
	sta	process_R0,x
.endmacro
.macro	addR1	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R1,x
	clc
	adc	value
	sta	process_R1,x
.endmacro
.macro	addR2	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R2,x
	clc
	adc	value
	sta	process_R2,x
.endmacro
.macro	addR3	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R3,x
	clc
	adc	value
	sta	process_R3,x
.endmacro
.macro	addR4	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R4,x
	clc
	adc	value
	sta	process_R4,x
.endmacro
.macro	addR5	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R5,x
	clc
	adc	value
	sta	process_R5,x
.endmacro
.macro	addR6	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R6,x
	clc
	adc	value
	sta	process_R6,x
.endmacro
.macro	addR7	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R7,x
	clc
	adc	value
	sta	process_R7,x
.endmacro

.macro	subR0	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R0,x
	sec
	sbc	value
	sta	process_R0,x
.endmacro
.macro	subR1	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R1,x
	sec
	sbc	value
	sta	process_R1,x
.endmacro
.macro	subR2	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R2,x
	sec
	sbc	value
	sta	process_R2,x
.endmacro
.macro	subR3	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R3,x
	sec
	sbc	value
	sta	process_R3,x
.endmacro
.macro	subR4	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R4,x
	sec
	sbc	value
	sta	process_R4,x
.endmacro
.macro	subR5	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R5,x
	sec
	sbc	value
	sta	process_R5,x
.endmacro
.macro	subR6	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R6,x
	sec
	sbc	value
	sta	process_R6,x
.endmacro
.macro	subR7	value, loadx
.ifnblank	loadx
	xpc
.endif
	lda	process_R7,x
	sec
	sbc	value
	sta	process_R7,x
.endmacro