errID_processput = 0
errID_noprocess = 1

engine_loop:
	lda	stadium_initrig 
	bne	engine_stadiuminit   
	ldx	#0
	lda	process_numof
	bne	process_hloop
	jmp	engine_stadiuminit

process_hloop:
	stx	process_count
	lda	process_pause,x
	bne	:+
	lda	process_AL,x
	sta	TC0
	lda	process_AH,x
	sta	TC1
	jsr	engine_indjump
:	inc	process_hcount
	ldx	process_count
	inx 
	cpx	process_numof
	bcc	process_hloop

	.include	"generated\lib_loop.asm"

;	joystats_get
;	lda	joy2_tap_select
;	beq	:+
;	jmp	paldebug
;:	
	jmp	engine_loop

engine_indjump:
	jmp	(TC0)
  
engine_stadiuminit:
	lda	stadium
	jsr	stadium_jt
	lda	stadium
	asl	A
	ldx	#0
	stx	stadium_initrig
	tax
	lda	stad_processdat_addr+0,x
	sta	TC0
	lda	stad_processdat_addr+1,x
	sta	TC1
	ldy	#$FF
:	iny
	lda	(TC0),y
	bmi	:+ 
	sty	TC2
	jsr	process_putR
	ldy	TC2
	iny
.if cfg_process_memslots > 0
	lda	(TC0),y
	beq	:-
	sta	TC2
	iny
	lda	(TC0),y
	sta	process_R0,x
.endif
.if cfg_process_memslots > 1
	dec	TC2
	beq	:-
	iny
	lda	(TC0),y
	sta	process_R1,x
.endif
.if cfg_process_memslots > 2
	dec	TC2
	beq	:-
	iny
	lda	(TC0),y
	sta	process_R2,x
.endif
.if cfg_process_memslots > 3
	dec	TC2
	beq	:-
	iny
	lda	(TC0),y
	sta	process_R3,x
.endif
.if cfg_process_memslots > 4
	dec	TC2
	beq	:-
	iny 
	lda	(TC0),y
	sta	process_R4,x
.endif
.if cfg_process_memslots > 5
	dec	TC2
	beq	:-
	iny
	lda	(TC0),y
	sta	process_R5,x
.endif
.if cfg_process_memslots > 6
	dec	TC2
	beq	:-
	iny
	lda	(TC0),y
	sta	process_R6,x
.endif
.if cfg_process_memslots > 7
	dec	TC2
	beq	:-
	iny
	lda	(TC0),y
	sta	process_R7,x
.endif
	jmp	:-
:	cmp	#$FE
	beq	:+
	cmp	#$FF
	beq	:++
	and	#$7F
	jsr	process_checkR
	bcc	:--
	jsr	process_kill_loop
	jmp	:--
:	jsr	process_reset
	jmp	:---
:	jmp	engine_loop

jumptable_handle:
	asl	A
	tay
	iny
	pla
	sta	TCB0
	pla
	sta	TCB1
	lda	(TCB0),y
	sta	TCB2
	iny
	lda	(TCB0),y
	sta	TCB3
	jmp	(TCB2)

jumptable_handle_NMI:
	asl	A
	tay
	iny
	pla
	sta	TN0
	pla
	sta	TN1
	lda	(TN0),y
	sta	TN2
	iny
	lda	(TN0),y
	sta	TN3
	jmp	(TN2)

;debug features later          

;paldebug:
;	lda	#0
;	sta	TC0
;paldebug_loop:
;	joystats_get
;	lda	joy_tap_A
;	beq	:+
;	inc	TC0
;:
;	lda	joy_tap_B
;	beq	:+
;	dec	TC0
;:
;	lda	joy_tap_up
;	beq	:+
;	ldx	TC0
;	lda	palette_source,x
;	clc
;	adc	#$10
;	sta	palette_source,x
;	sta	palette_buffer,x
;	inc	palette_update
;:	lda	joy_tap_down
;	beq	:+
;	ldx	TC0
;	lda	palette_source,x
;	sec
;	sbc	#$10
;	sta	palette_source,x
;	sta	palette_buffer,x
;	inc	palette_update
;:	lda	joy_tap_left
;	beq	:+
;	ldx	TC0
;	lda	palette_source,x 
;	sec
;	sbc	#1
;	sta	palette_source,x
;	sta	palette_buffer,x
;	inc	palette_update
;:	lda	joy_tap_right
;	beq	:+
;	ldx	TC0
;	lda	palette_source,x
;	clc
;	adc	#1
;	sta	palette_source,x
;	sta	palette_buffer,x
;	inc	palette_update
;:	jmp	paldebug_loop

process_reset:
	lda	#0
	sta	process_numof
	sta	process_count
	ldx	#cfg_process_limit-1
process_reset_loop:
	sta	process_ID,X
	sta	process_AH,X
	sta	process_AL,X
	sta	process_FC,x
	sta	process_pause,x
.if cfg_process_memslots > 0
	sta	process_R0,x
.endif
.if cfg_process_memslots > 1
	sta	process_R1,X
.endif
.if cfg_process_memslots > 2
	sta	process_R2,X
.endif
.if cfg_process_memslots > 3
	sta	process_R3,X
.endif
.if cfg_process_memslots > 4
	sta	process_R4,X
.endif
.if cfg_process_memslots > 5
	sta	process_R5,X
.endif
.if cfg_process_memslots > 6
	sta	process_R6,X
.endif
.if cfg_process_memslots > 7
	sta	process_R7,X
.endif
	dex
	bpl	process_reset_loop
	rts

.macro	process_init	ID, ope0, ope1, ope2, ope3, ope4, ope5, ope6, ope7
	lda	ID
	jsr	process_putR
.ifnblank		ope0
	lda	ope0
	sta	process_R0,x
.endif
.ifnblank		ope1
	lda	ope1
	sta	process_R1,x
.endif
.ifnblank		ope2
	lda	ope2
	sta	process_R2,x
.endif
.ifnblank		ope3
	lda	ope3
	sta	process_R3,x
.endif
.ifnblank		ope4
	lda	ope4
	sta	process_R4,x
.endif
.ifnblank		ope5
	lda	ope5
	sta	process_R5,x
.endif
.ifnblank		ope6
	lda	ope6
	sta	process_R6,x
.endif
.ifnblank		ope7
	lda	ope7
	sta	process_R7,x
.endif
.endmacro

process_putR:
	ldx	process_numof
	cpx	#cfg_process_limit
	beq	process_puterror
	sta	process_ID,x
	asl	A
	tay
	lda	process_addr+0,y
	sta	process_AL,x
	lda	process_addr+1,y
	sta	process_AH,x
	inc	process_numof
	rts
process_puterror:
	lda	#errID_processput
	sta	err_ID
	rts
  
.macro	check	ID
	lda	ID
	jsr	process_checkR
.endmacro
process_checkR:
	ldx	process_numof
	dex
process_checkRxset:
:	cmp	process_ID,x
	beq	:+
	dex
	bpl	:-
	clc
	rts
:	sec
	rts

.macro	pauseall
	jsr	pauseallR
.endmacro

pauseallR:
	ldx	process_numof
	lda	#1
:	sta	process_pause-1,x
	dex
	bne	:-
	xpc
	lda	#0
	sta	process_pause,x
	rts

.macro	unpauseall
	jsr	unpauseallR
.endmacro

unpauseallR:
	ldx	process_numof
	lda	#0
:	sta	process_pause-1,x
	dex
	bne	:- 
	rts

.macro	kill
	ldy	#0
	jmp	process_killR
.endmacro

.macro	killslot	slot
.ifnblank slot
	ldx	slot
.endif
	ldy	#1
	jsr	process_kill_loop
.endmacro
 
process_killR:
	ldx	process_count
process_kill_loop:
	cpx	#cfg_process_limit-1
	beq	process_kill_last
	inx
	cpx	process_numof
	beq	process_kill_last
	dex
	lda	process_ID+1,x
	sta	process_ID,x
	lda	process_AH+1,x
	sta	process_AH,x
	lda	process_AL+1,x
	sta	process_AL,x
	lda	process_FC+1,x
	sta	process_FC,x
	lda	process_pause+1,x
	sta	process_pause,x
.if cfg_process_memslots > 0
	lda	process_R0+1,x
	sta	process_R0,x
.endif
.if cfg_process_memslots > 1
	lda	process_R1+1,x
	sta	process_R1,x
.endif
.if cfg_process_memslots > 2
	lda	process_R2+1,x
	sta	process_R2,x
.endif
.if cfg_process_memslots > 3
	lda	process_R3+1,x 
	sta	process_R3,x
.endif
.if cfg_process_memslots > 4
	lda	process_R4+1,x 
	sta	process_R4,x
.endif
.if cfg_process_memslots > 5
	lda	process_R5+1,x 
	sta	process_R5,x
.endif
.if cfg_process_memslots > 6
	lda	process_R6+1,x 
	sta	process_R6,x
.endif
.if cfg_process_memslots > 7
	lda	process_R7+1,x 
	sta	process_R7,x
.endif
	inx 
	bpl	process_kill_loop
process_kill_last:
	dex
	lda	#0
	sta	process_ID,x
	sta	process_AH,x

	sta	process_AL,x
	sta	process_FC,x
	sta	process_pause,x
.if cfg_process_memslots > 0
	sta	process_R0,x 
.endif
.if cfg_process_memslots > 1
	sta	process_R1,x
.endif
.if cfg_process_memslots > 2
	sta	process_R2,x
.endif
.if cfg_process_memslots > 3
	sta	process_R3,x
.endif
.if cfg_process_memslots > 4
	sta	process_R4,x
.endif
.if cfg_process_memslots > 5
	sta	process_R5,x
.endif
.if cfg_process_memslots > 6
	sta	process_R6,x
.endif
.if cfg_process_memslots > 7
	sta	process_R7,x
.endif
	tya
	bne	:+
	sta	process_count
:	dec	process_numof
	rts
  
.macro	killtwin
	jsr	process_killtwinR
.endmacro

process_killtwinR:
	xpc
	lda	process_ID,x
	ldx	process_numof
:	dex
	clc
	bmi	:+	;end if last process
	jsr	process_checkRxset
	bcc	:+	;end if no more found
	cpx	process_count	;found one
	beq	:-	;find more if it's current process
	ldy	#1 
	jsr	process_kill_loop	;kill if twin
	sec
:	rts

.macro	stateset
	jsr	process_statesetR
.endmacro

process_statesetR:
	pla
	tax
	pla
	tay
	inx
	bne	:+
	iny
:
	txa
	ldx	process_count
	sta	process_AL,x
	tya
	sta	process_AH,x
	rts
 
.macro	statereset
	jsr	process_stateresetR
.endmacro
   
process_stateresetR:
	ldx	process_count
	lda	process_ID,x
	asl	A
	tay
	lda	process_addr+0,y
	sta	process_AL,x
	lda	process_addr+1,y
	sta	process_AH,x
	rts

.macro	set2006 addr
	lda	#>addr
	ldy	#<addr
	jsr	set2006R
.endmacro

set2006R:
	sta	$2006
	sty	$2006
	rts

set2006BR:
	stx	$2006
	sta	$2006
	rts

.macro	nametable_clear	table
	lda	table
	jsr	nametable_clearR
.endmacro

nametable_clearR:
	sta	$2006
	lda	#0
	sta	$2006

	ldx	#3
:
	tay
:
	sta	$2007
	dey
	bne	:-
	dex
	bpl	:--
	rts

.macro	blockfill blocktile, table
.ifnblank blocktile
	ldx	blocktile
.endif
.ifnblank table
	lda	table
.else
	lda	#$20
.endif
	jsr	blockfillR
.endmacro

blockfillR:
	stx	TC0
	inx
	inx
	stx	TC1
	ldy	#0
	jsr	set2006R
	ldy	#15
	sty	TC2
:	ldy	#15
	ldx	TC0
:	stx	$2007
	inx
	stx	$2007
	dex
	dey
	bpl	:-
	ldy	#15
	ldx	TC1
:	stx	$2007
	inx
	stx	$2007
	dex
	dey
	bpl	:-
	dec	TC2
	bne	:---
	rts

sprite_hide:
	lda	#$F8
	ldx	#$0
:
	sta	$200,x

	dex
	dex
	dex
	dex
	bne	:-
	rts

.macro	display_off
	jsr	display_offR
.endmacro
display_offR: 
	lda	ppuctrl0
	and	#%01111111
	sta	$2000
	sta	ppuctrl0
	lda	ppuctrl1
	and	#%11100111
	sta	$2001
	sta	ppuctrl1
;	sei

	lda	#0
	ldx	process_numof
	beq	:++
: 
	sta	process_FC,x 
	dex
	bpl	:- 
:
 
	ldx	#buffer_numof-1
:	sta	buffer_trigger,x
	dex
	bpl	:-
	rts

.macro	display_on
	jsr	display_onR
.endmacro
display_onR:
;	lda	$2002 
;	lda	#0
;	sta	$2006
;	sta	$2006
	lda	ppuctrl0 
	ora	#%10000000   
	sta	$2000 
	sta	ppuctrl0
	lda	ppuctrl1 
	ora	#%00011000 
	sta	$2001 
	sta	ppuctrl1 
;	cli
	rts 

.macro	ppuincreg_set
	jsr	PPUIncReg_SetR
.endmacro
PPUIncReg_SetR:
	lda	ppuctrl0
	ora	#%00000100
	sta	ppuctrl0
	sta	$2000
	rts

.macro	ppuincreg_clr
	jsr	PPUIncReg_ClrR
.endmacro
PPUIncReg_ClrR:
	lda	ppuctrl0
	and	#%11111011
	sta	ppuctrl0
	sta	$2000
	rts

.macro	ntrowcalc
	jsr	NTRowCalcR
.endmacro
NTRowCalcR:	;use: A = Collumn, X = Row
	ldy	#$20
	sty	TNB0
	and	#%00011111
	cpx	#0
	beq	:+++
:	clc
	adc	#$20
	bcc	:+
	inc	TNB0
:	dex
	bne	:--
:	ldy	TNB0
	sty	$2006
	sta	$2006
	rts

.macro	highnibb
	jsr	highnibbR
.endmacro
.ifref highnibbR

highnibbR:
	and	#$F0
	lsr	A
	lsr	A

	lsr	A
	lsr	A
	rts
.endif

.macro	decimalconv	
	jsr	decimalconvR
.endmacro

decimalconvR:
	ldx	#$FF
:	inx
	sec
	sbc	#$A
	bcs	:-
	adc	#$A
	rts

.macro	NMIEnforce
	php
	jsr	NMI
.endmacro

NMI:
	php
	pha
	txa
	pha
	tya
	pha

	lda	NMI_status
	beq	:+	
	jmp	nmi_done
:	lda	#1
	sta	NMI_status
 
;	jsr	display_offR
 
	lda	#0 
	sta	$2003 
	lda	#2 
	sta	$4014
	lda	$2002

	ldx	#buffer_numof-1
	lda	buffer_order
:	cmp	#buffer_numof
	bcc	:+
	sbc	#buffer_numof
:	pha
	tay
	lda	buffer_trigger,y
	bne	:+
	pla
	clc
	adc	#1
	dex
	bpl	:--
	bmi	:++

:
	tya
	jsr	buffer_jt
	pla
	tay
	lda	#0
	sta	buffer_trigger,y
	inc	buffer_order
	lda	buffer_order
	cmp	#buffer_numof
	bcc	:+
	sbc	#buffer_numof
	sta	buffer_order
:

	lda	#0
	tay
	jsr	set2006R

	lda	scrollX
	sta	$2005
	lda	scrollY
	sta	$2005

;	jsr	display_onR
 
	lda	process_hcount 
	sta	process_PPF
	lda	#0
	sta	process_hcount
 
	ldx	process_numof
	beq	:++
	dex
incprocessFC: 
	lda	process_pause,x
	bne	:+
	inc	process_FC,x 
:	dex
	bpl	incprocessFC
:
	.include	"generated\lib_nmi.asm"
	.include	"prj_nmi.asm"

	lda	#0
	sta	NMI_status
nmi_done:

	pla
	tay
	pla
	tax
	pla
	plp
	rti

.macro	IRQEnforce
	jsr	IRQ
.endmacro

IRQ:
	.include	"prj_irq.asm"
	rti

buffer_jt:
	jsr	jumptable_handle
	.include	"generated\lib_buff.asm"
