.macro	palload_source	label,srcstart,dststart,size  
.ifnblank dststart
	lda	dststart
.else
	lda	#0
.endif
	sta	TC2

.ifnblank size
	lda	size
.else
	lda	#0
.endif
	sta	TC3

	lda	#<label
	ldx	#>label

.ifnblank srcstart
	ldy	srcstart
.else
	ldy	#0
.endif

	jsr	palload_sourceR
.endmacro
palload_sourceR:
	sta	TC0
	stx	TC1
	ldx	TC2
:	lda	(TC0),y
	sta	palette_source,x
	inx
	iny
	dec	TC3
	bne	:-
	rts

.macro	palwrite_srcmem
	jsr	palwrite_srcmemR
.endmacro
palwrite_srcmemR:
	ldx	#$3F
	lda	#0
	jsr	set2006BR
	tax
:	lda	palette_source,x
	sta	palette_buffer,x
	sta	$2007
	inx
	cpx	#$20
	bne	:-
	rts

.macro	palwrite_buffer
	jsr	palwrite_bufferR
.endmacro
palwrite_bufferR:
	lda	#$3F
	ldy	#0
	jsr	set2006R
	ldx	#0
palwrite_buffer_loop:
	lda	palette_buffer,x
	sta	$2007
	inx
	cpx	#$20
	bne	palwrite_buffer_loop
	rts


.macro	palwrite_source	label,srcstart,dststart,size
.ifnblank srcstart
	lda	srcstart
.else
	lda	#0
.endif
	sta	TC2
.ifnblank size
.ifnblank srcstart
	lda	srcstart
	clc
	adc	size
.else
	lda	size
.endif
.else
.ifnblank srcstart
	lda	srcstart
	clc
	adc	#$20
.else
	lda	#$20
.endif
.endif
	sta	TC3
	lda	#<label
	ldx	#>label
.ifnblank dststart
	ldy	dststart
.else
	ldy	#0
.endif
	jsr	palwrite_sourceR
.endmacro
palwrite_sourceR:
	sta	TC0
	stx	TC1
	lda	#$3F
	jsr	set2006R	;Y is dststart
	ldy	TC2	;srcstart
:	lda	(TC0),y
	sta	$2007
	iny
	cpy	TC3	;srcstart+size
	bmi	:-
	rts


.macro	strbuffer_source label
	lda	#<label
	ldx	#>label
.endmacro

strbuffer_sourceR:
	sta	TC0
	stx	TC1
	ldy	#0
:	lda	(TC0),y
	sta	string_buffer,y
	bmi	:+
	iny
	ldx	#2
	jsr	strbuffer_source_subcopy
	tax
	jsr	strbuffer_source_subcopy
	bmi	:-
:	rts

strbuffer_source_subcopy:
:	lda	(TC0),y
	sta	string_buffer,y
	iny
	dex
	bpl	:-
	rts

.macro	strwrite_source	label
	lda	#<label
	ldx	#>label
	jsr	strwrite_sourceR
.endmacro
.macro	strwrite_buffer
	jsr	strwrite_bufferR
.endmacro
strwrite_bufferR:
	lda	#<string_buffer

	ldx	#>string_buffer
strwrite_sourceR:
	sta	TN0
	stx	TN1
	ldy	#0
:
	lda	(TN0),y
	bmi	:++
	iny
	tax
	lda	(TN0),y
	iny
	jsr	set2006BR
	lda	(TN0),y
	iny
	tax
:
	lda	(TN0),y 
	sta	$2007
	iny
	dex
	bpl	:-
	bmi	:--
:
	rts

.macro	constrbuffer_source	 label
	lda	#<label
	ldx	#>label
	jsr	constrbuffer_sourceR
.endmacro
constrbuffer_sourceR:
	sta	TC0 
	stx	TC1
	ldy	#$FF
constrbuffer_sourceR_loop:
	jsr	constrbuffer_sourceR_copy
	bpl	constrbuffer_sourceR_nt
	jsr	constrbuffer_sourceR_copy
	jmp	constrbuffer_sourceR_loop
constrbuffer_sourceR_nt:
	cmp	#$7F
	bne	:+
	rts
:	jsr	constrbuffer_sourceR_copy
	php
	jsr	constrbuffer_sourceR_copy
	bmi	:+
	jsr	constrbuffer_sourceR_copy
:	plp
	bmi	constrbuffer_sourceR_loop
	jsr	constrbuffer_sourceR_copy
:	bne	constrbuffer_sourceR_loop
constrbuffer_sourceR_copy:
	iny
	lda	(TC0),y
	sta	constr_buffer,y
	rts

.macro	cvbbuffer_source	label
	lda	#<label
	ldx	#>label
	jsr	cvbbuffer_sourceR
.endmacro
.macro	cvbbuffer_constrbfr
	jsr	cvbbuffer_constrbfrR
.endmacro
cvbbuffer_constrbfrR:
	lda	#<constr_buffer
	ldx	#>constr_buffer
cvbbuffer_sourceR:   
	sta	TCB0
	stx	TCB1 
	jsr	cvb_reset
	ldy	#$FF
cvbbuffer_loop:
	lda	#0
	sta	TC2
	sta	TC3
	sta	TC4
	iny
	lda	(TCB0),y
	cmp	#$7F
	bne	:+
	jmp	cvbbuffer_end
:
	lda	(TCB0),y
	bpl	:+
	jmp	cvbbuffer_attr
:
	pha
	iny
	lda	(TCB0),y
	php

	and	#%01111111
	tax
	iny
	lda	(TCB0),y
	php
	sty	TC0

	ldy	#$20
	sty	TCB2
	and	#%00011111
	cpx	#0
	beq	:+++
:	clc
	adc	#$20
	bcc	:+
	inc	TCB2
:	dex
	bne	:--
:	pha
	lda	TCB2
	
	jsr	cvb_addbyte
	pla
	jsr	cvb_addbyte

	ldy	TC0
	iny	;Y shall be chunk+3.
	plp
	bpl	:+
	lda	#0
	beq	:++
:	lda	(TCB0),y
	iny
:	sta	TC0
	plp
	bpl	:+
	lda	#0
	sta	TC1
	beq	cvbbuffer_writestart
:
	lda	(TCB0),y
	rol	A
	bcs	:+
	ldx	#0
	beq	:++
:	ldx	#$10
:	stx	TC1
	rol	A
	pha
	ldx	#$FE
	lda	#0
	ror	A
	ror	A
	jsr	cvb_orarel
	pla
	rol	A
	rol	TC2
	rol	A
	rol	TC2
	rol	A
	rol	TC3
	rol	A
	rol	TC3
	rol	A
	rol	TC4
	rol	A
	rol	TC4
	iny

cvbbuffer_writestart:
	pla
	jsr	cvb_addbyte
	tax
	lda	TC0
:	jsr	cvb_addbyte
	dex
	cpx	#$FF
	beq	:+
	clc
	adc	TC2
	pha 
	adc	TC4
	jsr	cvb_addbyte
	pla
	clc 
	adc	TC3
	adc	TC1
	dex
	bpl	:-
:	dey
	jmp	cvbbuffer_loop
cvbbuffer_end:
	inc	cvb_write
	rts

cvbbuffer_attr:
	tax
	and	#%00110000
	sta	TC2
	asl	A
	rol	A
	sta	TC3
	rol	A
	rol	A
	rol	A
	sta	TC0	;palette#
	rol	A
	rol	A
	sta	TC1
	tya
	pha	;store CONSTR data pointer
	txa
	and	#%00001111	;run-length
	clc
	adc	#1
	pha
	txa
	and	#%01000000
	pha
	iny
	lda	(TCB0),y
	tax
	and	#%00001111
	lsr	A
	sta	TC4	;X byte
	lda	#0
	rol	A
	sta	TC5	;X block
	txa
	and	#%11100000
	lsr	A
	lsr	A
	adc	TC4
	pha	;byte#
	txa
	and	#%00010000
	lsr	A
	lsr	A
	lsr	A
	adc	TC5
	tay	;coordinate
	pla
	tax	;attribute table byte
	pla
	sta	TC5	;direction type
	pla 
	sta	TC4	;lenght of line
cvbbuffer_attr_loop:
	txa
	ora	#$C0
	jsr	cvb_addbyte
	lda	constrwrite_attr_andmask,y
	jsr	cvb_addbyte
	lda	TC0,y
	jsr	cvb_addbyte

	lda	TC5
	bne	:++
;horizontal incerase
	iny
	tya
	ror	A
	bcs	:++++
	dey
	dey
	inx
	txa
	and	#7
	bne	:++++
	cpy	#2
	bcs	:+
	dex
	txa     
	and	#%00111000   
	tax
	iny
	iny
	bpl	:++++
:	dey
	dey
	bpl	:+++
;vertical incerase
:
	iny
	iny
	cpy	#4
	bcc	:++
	tya
	and	#1
	tay
	txa
	clc
	adc	#8
	tax
	cpx	#$40
	bcc	:++
	and	#7
	tax
	tya
	ror	A
	bcs	:+
	iny
	jmp	:++
:	inx
	dey

:	dec	TC4
	bne	cvbbuffer_attr_loop

	pla
	tay
	iny
	jmp	cvbbuffer_loop

.macro	constrwrite_source	label
	lda	#<label
	ldx	#>label
	jsr	constrwrite_sourceR
.endmacro
.macro	constrwrite_buffer
	jsr	constrwrite_bufferR
.endmacro
constrwrite_bufferR:
	lda	#<constr_buffer
	ldx	#>constr_buffer
constrwrite_sourceR:   
	sta	TN6
	stx	TN7
	ldy	#$FF
constrwrite_loop:
	jsr	PPUIncReg_ClrR

	lda	#0
	sta	TN2
	sta	TN3
	sta	TN4
	iny
	lda	(TN6),y
	cmp	#$7F
	bne	:+
	jmp	constrwrite_end
:
	lda	(TN6),y

	bpl	:+
	jmp	constrwrite_attr
:
	pha
	iny
	lda	(TN6),y
	php
	and	#%01111111
	tax
	iny
	lda	(TN6),y
	php
	and	#%01111111
	sty	TN0
	jsr	NTRowCalcR
	ldy	TN0
	iny	;Y shall be chunk+3.
	plp
	bpl	:+
	lda	#0
	beq	:++
:	lda	(TN6),y
	iny
:	sta	TN0
	plp
	bpl	:+
	lda	#0
	sta	TN2
	beq	constrwrite_writestart
:
	lda	(TN6),y
	rol	A
	bcs	:+
	ldx	#0
	beq	:++
:	ldx	#$10
:	stx	TN1
	rol	A
	bcc	:+
	pha
	jsr	PPUIncReg_SetR
	pla
:	rol	A
	rol	TN2
	rol	A
	rol	TN2
	rol	A
	rol	TN3
	rol	A
	rol	TN3
	rol	A
	rol	TN4
	rol	A
	rol	TN4
	iny

constrwrite_writestart:
	pla
	tax
	lda	TN0
:	sta	$2007
	dex
	cpx	#$FF
	beq	:+
	clc
	adc	TN2
	pha 
	adc	TN4
	sta	$2007
	pla
	clc 
	adc	TN3
	adc	TN1
	dex
	bpl	:-
:	dey
	jmp	constrwrite_loop
constrwrite_end:
	jsr	PPUIncReg_ClrR
	rts

constrwrite_attr:
	tax
	and	#%00110000
	sta	TN2
	asl	A
	rol	A
	sta	TN3
	rol	A
	rol	A
	rol	A
	sta	TN0	;palette#
	rol	A
	rol	A
	sta	TN1
	tya
	pha	;store CONSTR data pointer
	txa
	and	#%00001111	;run-length
	clc
	adc	#1
	pha
	txa
	and	#%01000000
;	asl	A
;	asl	A
;	sta	TN5	;draw direction
	pha
	iny
	lda	(TN6),y
	tax
	and	#%00001111
	lsr	A
	sta	TN4	;X byte
	lda	#0
	rol	A
	sta	TN5	;X block
	txa
	and	#%11100000
	lsr	A
	lsr	A
	adc	TN4
	pha	;byte#
	txa
	and	#%00010000

	lsr	A
	lsr	A
	lsr	A
	adc	TN5
	tay
	pla
	tax
	pla
	sta	TN5
	pla 
	sta	TN4
constrwrite_attr_loop:
	stx	TNB0
	txa
	clc
	adc	#$C0
	ldx	#$23
	jsr	set2006BR
	lda	$2007
	lda	$2007
	and	constrwrite_attr_andmask,y
	ora	TN0,y
	pha
	ldx	TNB0
	txa
	clc
	adc	#$C0
	ldx	#$23
	jsr	set2006BR
	pla
	sta	$2007
	ldx	TNB0

	lda	TN5
	bne	:++
;horizontal incerase
	iny
	tya
	ror	A
	bcs	:++++
	dey
	dey
	inx
	txa
	and	#7
	bne	:++++
	cpy	#2
	bcs	:+
	dex
	txa     
	and	#%00111000   
	tax
	iny
	iny
	bpl	:++++
:	dey
	dey
	bpl	:+++
;vertical incerase
:
	iny
	iny
	cpy	#4
	bcc	:++
	tya
	and	#1
	tay
	txa
	clc
	adc	#8
	tax
	cpx	#$40
	bcc	:++
	and	#7
	tax
	tya
	ror	A
	bcs	:+
	iny
	jmp	:++
:	inx
	dey

:	dec	TN4
	bne	constrwrite_attr_loop

	pla
	tay
	iny
	jmp	constrwrite_loop

constrwrite_attr_andmask:
	.byte %11111100, %11110011, %11001111, %00111111

cvb_reset:
	lda	#0
	sta	cvb_pointer
	sta	cvb_length
	rts

cvb_orarel:
	pha
	tya

	pha
	txa
	pha
	clc
	adc	cvb_pointer
	tay
	tsx
	lda	$103,x
	ora	cvbuffer,y
	sta	cvbuffer,y
	pla
	tax
	pla
	tay
	pla
	rts

cvb_addbyte:
	pha
	txa
	pha
	tsx
	lda	$102,x
	ldx	cvb_pointer
	cpx	cvb_length
	bcc	:+
	pha
	lda	#0
	sta	cvbuffer,x
	inc	cvb_length
	pla
:	ora	cvbuffer,x
	sta	cvbuffer,x
	inc	cvb_pointer
	pla
	tax
	pla
	rts

;cvb_attrchunk:
;	pha
;	txa
;	pha
;	tya
;	pha
;	tsx
;	ldy	#0
;:	lda	cvbuffer,y
;	bmi	:+
;	iny
;	iny
;	tya
;	clc
;	adc	cvbuffer,y
;	tay
;	jmp	:-
;:	cmp	$102,x
;	beq	:+
;	cpy	cvbuffer_length
;	
;
;:	sty	cvb_pointer
;	pla
;	tay
;	pla
;	tax
;	pla
;	rts

.macro	cvbwrite_buffer
	jsr	cvbwrite_bufferR
.endmacro
cvbwrite_bufferR:
	lda	#<cvbuffer
	ldx	#>cvbuffer
cvbwrite_sourceR:
	sta	TN0
	stx	TN1 
	ldy	#0
cvbwrite_loop:
	cpy	cvb_length
	bcc	:+
	rts
:	lda	(TN0),y
	bpl	cvbwrite_definitive
	ldx	#$23
	stx	$2006
	sta	$2006
	sta	TN2
	lda	$2007
	lda	$2007
	iny
	and	(TN0),y
	iny
	ora	(TN0),y
	pha
	ldx	#$23
	stx	$2006
	lda	TN2
	sta	$2006
	pla
	sta	$2007
	iny
	jmp	cvbwrite_loop
cvbwrite_definitive:
	sta	$2006
	iny
	lda	(TN0),y
	sta	$2006
	iny
	lda	(TN0),y
	tax
	iny
:	lda	(TN0),y
	sta	$2007
	iny
	dex
	bpl	:-
	bmi	cvbwrite_loop